/*
** This program is free software: you can redistribute it and/or modify
** it under the terms of the GNU Affero General Public License as
** published by the Free Software Foundation, either version 3 of the
** License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU Affero General Public License for more details.
**
** You may find a copy of the GNU Affero GPL version 3 at the following
** location: https://www.gnu.org/licenses/agpl-3.0.en.html
** 
** Additional terms under GNU Affero GPL version 3 section 7:
** 
**   Under Section 7 of the GNU Affero GPL version 3, the following additional
**   terms apply to the works covered under the License.  These additional terms
**   are non-permissive additional terms allowed under Section 7 of the GNU
**   Affero GPL version 3 and may not be removed by you.
** 
**   0. Attribution Requirement.
** 
**     You must preserve all legal notices or author attributions in the covered
**     work or Appropriate Legal Notices displayed by works containing the covered
**     work.  You may not remove from the covered work any author or developer
**     credit already included within the covered work.
** 
**   1. No License To Use Trademarks.
** 
**     This license does not grant any license or rights to use the trademarks
**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
**     of Golden Code Development Corporation. You are not authorized to use the
**     name Golden Code, FWD, or the names of any author or contributor, for
**     publicity purposes without written authorization.
** 
**   2. No Misrepresentation of Affiliation.
** 
**     You may not represent yourself as Golden Code Development Corporation or FWD.
** 
**     You may not represent yourself for publicity purposes as associated with
**     Golden Code Development Corporation, FWD, or any author or contributor to
**     the covered work, without written authorization.
** 
**   3. No Misrepresentation of Source or Origin.
** 
**     You may not represent the covered work as solely your work.  All modified
**     versions of the covered work must be marked in a reasonable way to make it
**     clear that the modified work is not originating from Golden Code Development
**     Corporation or FWD.  All modified versions must contain the notices of
**     attribution required in this license.
*/

// On Windows, you must install mingw from http://mingw-w64.sourceforge.net or
// from http://www.drangon.org/mingw. Take one of the full archives:
// mingw-w32-bin-i686-2013MMDD.7z or mingw-w64-bin-x86_64-2013MMDD.7z and unpack
// it to c:\.  Then include The c:\mingw32\bin\ or c:\mingw64\bin\ to the PATH
// variable, depending on the Windows architecture in use. We have not had good
// luck using the automatic installer for mingw.

// Then compile using this:
// gcc dump_syscolor.c -o dump_syscolor.exe
                            
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

void dumpColor(char* name, int num)
{
   // see API docs at https://msdn.microsoft.com/en-us/library/windows/desktop/ms724371%28v=vs.85%29.aspx
   DWORD color = GetSysColor(num);
   
   printf("%s (%d) = 0x%08X (%d, %d, %d)\n",
          name,
          num,
          color,
          GetRValue(color),
          GetGValue(color),
          GetBValue(color));  
}

void main(int argc, char* argv)
{
   dumpColor("COLOR_SCROLLBAR", COLOR_SCROLLBAR);
   dumpColor("COLOR_BACKGROUND", COLOR_BACKGROUND);
   dumpColor("COLOR_DESKTOP", COLOR_DESKTOP);
   dumpColor("COLOR_ACTIVECAPTION", COLOR_ACTIVECAPTION);
   dumpColor("COLOR_INACTIVECAPTION", COLOR_INACTIVECAPTION);
   dumpColor("COLOR_MENU", COLOR_MENU);
   dumpColor("COLOR_WINDOW", COLOR_WINDOW);
   dumpColor("COLOR_WINDOWFRAME", COLOR_WINDOWFRAME);
   dumpColor("COLOR_MENUTEXT", COLOR_MENUTEXT);
   dumpColor("COLOR_WINDOWTEXT", COLOR_WINDOWTEXT);
   dumpColor("COLOR_CAPTIONTEXT", COLOR_CAPTIONTEXT);
   dumpColor("COLOR_ACTIVEBORDER", COLOR_ACTIVEBORDER);
   dumpColor("COLOR_INACTIVEBORDER", COLOR_INACTIVEBORDER);
   dumpColor("COLOR_APPWORKSPACE", COLOR_APPWORKSPACE);
   dumpColor("COLOR_HIGHLIGHT", COLOR_HIGHLIGHT);
   dumpColor("COLOR_HIGHLIGHTTEXT", COLOR_HIGHLIGHTTEXT);
   dumpColor("COLOR_3DFACE", COLOR_3DFACE);
   dumpColor("COLOR_3DSHADOW", COLOR_3DSHADOW);
   dumpColor("COLOR_GRAYTEXT", COLOR_GRAYTEXT);
   dumpColor("COLOR_BTNTEXT", COLOR_BTNTEXT);
   dumpColor("COLOR_INACTIVECAPTIONTEXT", COLOR_INACTIVECAPTIONTEXT);
   dumpColor("COLOR_BTNHIGHLIGHT", COLOR_BTNHIGHLIGHT);
   dumpColor("COLOR_3DDKSHADOW", COLOR_3DDKSHADOW);
   dumpColor("COLOR_3DLIGHT", COLOR_3DLIGHT);
   dumpColor("COLOR_INFOTEXT", COLOR_INFOTEXT);
   dumpColor("COLOR_INFOBK", COLOR_INFOBK);
   dumpColor("UNNAMED", 25);
   dumpColor("COLOR_HOTLIGHT", COLOR_HOTLIGHT);
   dumpColor("COLOR_GRADIENTACTIVECAPTION", COLOR_GRADIENTACTIVECAPTION);
   dumpColor("COLOR_GRADIENTINACTIVECAPTION", COLOR_GRADIENTINACTIVECAPTION);
   dumpColor("COLOR_MENUHILIGHT", COLOR_MENUHILIGHT);
   dumpColor("COLOR_MENUBAR", COLOR_MENUBAR);
}
